// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "xkeymacs.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define WM_USER_NTFYICON (WM_USER+100)

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(IDC_ABOUT, OnAbout)
	ON_COMMAND(IDC_QUIT, OnQuit)
	ON_COMMAND(IDC_STOP, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here

	m_pXkeymacsDll = new CXkeymacsDll;
	m_pXkeymacsDlg = new CXkeymacsDlg;
	m_bDialogExist = FALSE;
	m_nDialogExist = -1;

	// register window class
	WNDCLASS	stWndClass;
	CString szClassName;
	szClassName.LoadString(AFX_IDS_APP_TITLE);
	CString szWindowName;
	szWindowName.LoadString(AFX_IDS_APP_TITLE);

	stWndClass.style			= CS_BYTEALIGNWINDOW;
	stWndClass.lpfnWndProc		= &AfxWndProc;
	stWndClass.cbClsExtra		= 0;
	stWndClass.cbWndExtra		= 0;
	stWndClass.hInstance		= AfxGetInstanceHandle();
	stWndClass.hIcon			= NULL;
	stWndClass.hCursor			= NULL;
	stWndClass.hbrBackground	= (HBRUSH)COLOR_BACKGROUND;
	stWndClass.lpszMenuName		= NULL;
	stWndClass.lpszClassName	= szClassName;

	AfxRegisterClass(&stWndClass);

	// make window
	CRect	rect(0, 0, 100, 100);

	Create(szClassName, szWindowName, WS_OVERLAPPEDWINDOW | WS_MINIMIZE, rect);
}

CMainFrame::~CMainFrame()
{
	delete m_pXkeymacsDll;
	delete m_pXkeymacsDlg;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// display icon in task tray
	m_stNtfyIcon.cbSize				= sizeof(NOTIFYICONDATA);
	m_stNtfyIcon.uID				= 0;
	m_stNtfyIcon.hWnd				= m_hWnd;
	m_stNtfyIcon.uFlags				= NIF_MESSAGE | NIF_ICON | NIF_TIP;
	m_stNtfyIcon.hIcon				= AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_stNtfyIcon.uCallbackMessage	= WM_USER_NTFYICON;
	LoadString(AfxGetInstanceHandle(), AFX_IDS_APP_TITLE, m_stNtfyIcon.szTip, sizeof(m_stNtfyIcon.szTip));
	::Shell_NotifyIcon(NIM_ADD, &m_stNtfyIcon);

	m_pXkeymacsDll->SetKeyboardHook();

	return 0;
}

//DEL BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
//DEL {
//DEL 	if (!CFrameWnd::PreCreateWindow(cs))
//DEL 		return FALSE;
//DEL 	// TODO: Modify the Window class or styles here by modifying
//DEL 	//  the CREATESTRUCT cs
//DEL 
//DEL 	return TRUE;
//DEL }

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

// get message of icon on system tray
LRESULT CMainFrame::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	switch (message) {
	case WM_USER_NTFYICON:
		if (lParam == WM_LBUTTONDOWN) {
			if (!m_bDialogExist) {
				m_bDialogExist = TRUE;
				m_nDialogExist = m_pXkeymacsDlg->DoModal();
				m_bDialogExist = FALSE;
				EnableWindow(FALSE);
			} else {
				m_pXkeymacsDlg->SetForegroundWindow();
			}
		}
		else if (lParam == WM_RBUTTONDOWN)
			ShowRightMenu();
		return 0;
	}
	
	return CFrameWnd::WindowProc(message, wParam, lParam);
}

void CMainFrame::OnAbout() 
{
	// TODO: Add your command handler code here
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
	EnableWindow(FALSE);
}

void CMainFrame::OnQuit() 
{
	// TODO: Add your command handler code here
	if (m_bDialogExist)
		m_pXkeymacsDlg->EndDialog(m_nDialogExist);

	m_pXkeymacsDll->ReleaseKeyboardHook();

	::Shell_NotifyIcon(NIM_DELETE, &m_stNtfyIcon);
	PostQuitMessage(0);
}

// show right menu on icon in system tray
void CMainFrame::ShowRightMenu()
{
	CMenu rightMenu;
	rightMenu.LoadMenu(IDR_RIGHT_MENU);

	CMenu *popUp = rightMenu.GetSubMenu(0);

	if (m_pXkeymacsDll->IsKeyboardHook()) {
		popUp->CheckMenuItem(IDC_STOP, MF_UNCHECKED | MF_BYCOMMAND);
	} else {
		popUp->CheckMenuItem(IDC_STOP, MF_CHECKED | MF_BYCOMMAND);
	}

	SetForegroundWindow();

	CPoint pt;
	GetCursorPos(&pt);
	popUp->TrackPopupMenu(TPM_RIGHTBUTTON, pt.x, pt.y, this);
}

// stop/start keyboard hook
void CMainFrame::OnStop() 
{
	// TODO: Add your command handler code here
	if (m_pXkeymacsDll->IsKeyboardHook()) {
		m_pXkeymacsDll->ReleaseKeyboardHook();
	} else {
		m_pXkeymacsDll->SetKeyboardHook();
	}
}

BOOL CMainFrame::DialogExist()
{
	return m_bDialogExist;
}
