// xkeymacsdll.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "resource.h"
#include <afxdllx.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static AFX_EXTENSION_MODULE XkeymacsdllDLL = { NULL, NULL };

static HINSTANCE g_hDllInst = NULL;

HINSTANCE GetThisHInst()
{
	return g_hDllInst;
}

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	g_hDllInst = hInstance;
	
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("XKEYMACSDLL.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(XkeymacsdllDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(XkeymacsdllDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("XKEYMACSDLL.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(XkeymacsdllDLL);
	}
	return 1;   // ok
}

//////////////////////////////////////////////////////////////////////
// CXkeymacsDll Class
//////////////////////////////////////////////////////////////////////

#include "xkeymacsDll.h"
#pragma data_seg(".xkeymacs")
	HHOOK	CXkeymacsDll::m_hHook = NULL;
	int		CXkeymacsDll::m_nEnable[MAX_APP][MAX_COMMAND_TYPE][MAX_KEY] = {'\0'};
	char	CXkeymacsDll::m_szSpecialApp[MAX_APP][CLASS_NAME_LENGTH] = {'\0'};
	HWND	CXkeymacsDll::m_hPrevWnd = 0;
#pragma data_seg()

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXkeymacsDll::CXkeymacsDll()
{

}

CXkeymacsDll::~CXkeymacsDll()
{

}


// set keyboard hook
BOOL CXkeymacsDll::SetKeyboardHook()
{
	m_hHook = ::SetWindowsHookEx(WH_KEYBOARD, (HOOKPROC)KeyboardProc, GetThisHInst(), 0);

	if(!m_hHook)
		return FALSE;

	return TRUE;
}

// release keyboard hook
BOOL CXkeymacsDll::ReleaseKeyboardHook()
{
	BOOL bRes = TRUE;

	if(m_hHook)
		bRes = ::UnhookWindowsHookEx(m_hHook);

	m_hHook = NULL;
	return bRes;
}

// if be keyboard hook, return TRUE
BOOL CXkeymacsDll::IsKeyboardHook()
{
	if (m_hHook)
		return TRUE;

	return FALSE;
}

// return true if control is down
inline BOOL CXkeymacsDll::IsControlDown()
{
	return (GetKeyState(VK_CONTROL) < 0);
}

// return true if alt is down
inline BOOL CXkeymacsDll::IsAltDown()
{
	return (GetKeyState(VK_MENU) < 0);
}

// return true if shift is down
inline BOOL CXkeymacsDll::IsShiftDown()
{
	return (GetKeyState(VK_SHIFT) < 0);
}

// return true if numlock is on
inline BOOL CXkeymacsDll::IsNumLockOn()
{
	return (GetKeyState(VK_NUMLOCK) & 0x01);
}

// the key is being depressed
inline void CXkeymacsDll::DepressKey(BYTE bVk)	// bVk is virtual-key code, MSDN said
{
	keybd_event(bVk, 0, 0, 0);
}

// the key is being released
inline void CXkeymacsDll::ReleaseKey(BYTE bVk)	// bVk is virtual-key code, MSDN said
{
	keybd_event(bVk, 0, KEYEVENTF_KEYUP, 0);
}

// bVk down, bVk up
inline void CXkeymacsDll::Kdu(BYTE bVk)
{
	DepressKey(bVk);
	ReleaseKey(bVk);
}

// control up, bVk down, bVk up, control down
inline void CXkeymacsDll::CuKduCd(BYTE bVk)
{
	BYTE ks[256];

	GetKeyboardState( ks );
	ks[ VK_CONTROL ] = 0;
	SetKeyboardState( ks );

	ReleaseKey(VK_CONTROL);
	Kdu(bVk);
	DepressKey(VK_CONTROL);

	GetKeyboardState( ks );
	ks[ VK_CONTROL ] = 1;
	SetKeyboardState( ks );
}

// if control is down: control up, atl down, bVk down, bVk up, alt up, control down
inline void CXkeymacsDll::CuAdKduAuCd(BYTE bVk)
{
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_MENU);
	Kdu(bVk);
	ReleaseKey(VK_MENU);
	DepressKey(VK_CONTROL);
}

// if control is down: control up, atl down, bVk1 down, bVk1 up, bVk3 down, bVk2 up, alt up, control down
inline void CXkeymacsDll::CuAdKduKduAuCd(BYTE bVk1, BYTE bVk2)
{
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_MENU);
	Kdu(bVk1);
	Kdu(bVk2);
	ReleaseKey(VK_MENU);
	DepressKey(VK_CONTROL);
}

// control up, shift down, bVk down, bVk up, shift up, control down
inline void CXkeymacsDll::CuSdKduSuCd(BYTE bVk)
{
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_SHIFT);
	Kdu(bVk);
	ReleaseKey(VK_SHIFT);
	DepressKey(VK_CONTROL);
}

// control up, shift down, bVk1 down, bVk1 up, bVk2 down, bVk2 up, shift up, control down
inline void CXkeymacsDll::CuSdK1duK2duSuCd(BYTE bVk1, BYTE bVk2)
{
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_SHIFT);
	Kdu(bVk1);
	Kdu(bVk2);
	ReleaseKey(VK_SHIFT);
	DepressKey(VK_CONTROL);
}

// alt up, bVk down, bVk up, alt down
inline void CXkeymacsDll::AuKduAd(BYTE bVk)
{
	ReleaseKey(VK_MENU);
	Kdu(bVk);
	DepressKey(VK_MENU);
}

// alt up, control down, bVk down, bVk up, control up, alt down
inline void CXkeymacsDll::AuCdKduCuAd(BYTE bVk)
{
	ReleaseKey(VK_MENU);
	DepressKey(VK_CONTROL);
	Kdu(bVk);
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_MENU);
}

inline BOOL CXkeymacsDll::CopyBackCharacter()
{
	if (!OpenClipboard(NULL))
		return FALSE;
	if (!EmptyClipboard())
		return FALSE;
	if (!CloseClipboard())
		return FALSE;

	CuSdKduSuCd(VK_LEFT);
	Kdu('C');
	CuKduCd(VK_RIGHT);

	return TRUE;
}

// Copy next character of the cursor
inline BOOL CXkeymacsDll::CopyNextCharacter()
{
	if (!OpenClipboard(NULL))
		return FALSE;
	if (!EmptyClipboard())
		return FALSE;
	if (!CloseClipboard())
		return FALSE;

	CuSdKduSuCd(VK_RIGHT);
	Kdu('C');
	CuKduCd(VK_LEFT);

	return TRUE;
}

// control up, VK_KANJI down, VK_KANJI up, control down
inline void CXkeymacsDll::ToggleIME()
{
	CuKduCd(VK_KANJI);
}

void CXkeymacsDll::ToggleNumLock()
{
	if (IsControlDown())
		CuKduCd(VK_NUMLOCK);
	else if (IsAltDown())
		AuKduAd(VK_NUMLOCK);
	else
		Kdu(VK_NUMLOCK);	// Is this right?
}

// noone is useing this function because IsNumLockOn is not always correct 
//void CXkeymacsDll::NumLockOn()
//{
	// Think naturally this sentence should be as follows.
	//		if (!IsNumLockOn())
	// But OS does not notice that NumLock is toggled yet,
	// so this sentece must be as follows.
//	if (IsNumLockOn()) {
//		ToggleNumLock();
//	}
//}

void CXkeymacsDll::NumLockOff()
{
	if (IsNumLockOn()){
		ToggleNumLock();
	}
}

// emulate emacs	// cf virtual-key code
LRESULT CALLBACK CXkeymacsDll::KeyboardProc(int code, WPARAM wParam, LPARAM lParam)
{
	static BOOL	bC_x	= FALSE;
	static BOOL bOriginalC_v = FALSE;
	static BOOL bOriginalC_x = FALSE;
	static BOOL bOriginalC_z = FALSE;
	static int	nRepeat	= 0;
	HWND hCurrentWnd = GetFocus();
	static char szApplicationName[MAX_PATH];
	static int nApp = 0;
	BOOL bNumLockChanged = FALSE;

	if (code < 0 || code == HC_NOREMOVE)
		goto DO_NOTHING;

	if (lParam & 0x80000000)
		goto DO_NOTHING;

	if (m_hPrevWnd != hCurrentWnd) {
		GetModuleFileName(NULL, szApplicationName, sizeof(szApplicationName));
		CString szFn(szApplicationName);
		szFn.Delete(0, szFn.ReverseFind('\\') + 1);
		ZeroMemory(szApplicationName, sizeof(szApplicationName));
		strncpy(szApplicationName, szFn, szFn.GetLength());

		if (strnicmp(m_szSpecialApp[nApp], szApplicationName, sizeof(szApplicationName))) {
			for (nApp = 0; nApp < MAX_APP; nApp++) {
				if (!strnicmp(m_szSpecialApp[nApp], szApplicationName, sizeof(szApplicationName))) {
					break;
				}
			}
			if (nApp == MAX_APP) {
				for (nApp = 0; nApp < MAX_APP; nApp++) {
					CString szDefault(IDS_DEFAULT);	// Is it work correct??? Delete! Use only static function. i.e. do not use string resource
					if (!strnicmp(m_szSpecialApp[nApp], szDefault, sizeof(szApplicationName))) {
						break;
					}
				}
				if (nApp == MAX_APP)
					nApp = 0;
			}
		}
		m_hPrevWnd	= hCurrentWnd;
		bC_x		= FALSE;
		nRepeat		= 0;
	}

	if (IsControlDown()) {
		if (bC_x) {
			if (!m_nEnable[nApp][CONTROLX][wParam] && !m_nEnable[nApp][CONTROL][wParam]) {
				goto DO_NOTHING;
			}
		} else if (!m_nEnable[nApp][CONTROL][wParam]) {
			goto DO_NOTHING;
		}
	} else if (IsAltDown()) {
		if (!m_nEnable[nApp][META][wParam])
			goto DO_NOTHING;
	} else {
		if (!m_nEnable[nApp][NONE][wParam])
			if (!nRepeat) {
				goto DO_NOTHING;
			} else {
				while(nRepeat--) {
					ASSERT(0 <= wParam && wParam <= UCHAR_MAX);
					Kdu((BYTE)wParam);
				}
				goto HOOK;
			}
	}

	// this is too difficult for me. change more simple!
	if (IsNumLockOn()														&&
		!((IsControlDown() && ('0' <= wParam) && (wParam <= '9'))	||
		  (IsControlDown() && (wParam == 'S') && !bC_x)				||
		  (IsControlDown() && (wParam == 0xBF))						||
		  (IsAltDown())												||
		  ((wParam == 'U') && bC_x)										)		) {
		NumLockOff();
		bNumLockChanged = TRUE;
	}

	// C-?
	if (IsControlDown()) {
		switch (wParam) {
		case 'A':
			// C-a: Home
			CuKduCd(VK_HOME);
			goto HOOK;

		case 'B':
			// C-b: Left
			if (!nRepeat)
				nRepeat = 1;
			while (nRepeat--)
				CuKduCd(VK_LEFT);
			goto HOOK;

		case 'C':
			// C-x C-c: Alt-F4
			if (bC_x) {
				if (strnicmp(szApplicationName, "explorer.exe", sizeof(szApplicationName)))
					CuAdKduKduAuCd(VK_SPACE, 'C');
				else
					CuAdKduAuCd(VK_F4);
				goto HOOK;
			} else
				break;

		case 'D':
			// C-d: Delete
			if (!nRepeat)
				nRepeat = 1;
			while (nRepeat--)
				CuKduCd(VK_DELETE);
			goto HOOK;

		case 'E':
			// C-e: End
			CuKduCd(VK_END);
			goto HOOK;

		case 'F':
			// C-x C-f: Alt-f, Alt-o
			if (bC_x) {
				CuAdKduKduAuCd('F', 'O');
				goto HOOK;
			}

			// C-f: Right
			if (!nRepeat)
				nRepeat = 1;
			while (nRepeat--)
				CuKduCd(VK_RIGHT);
			goto HOOK;

		case 'G':
			// C-g:
			goto HOOK;

		case 'H':
			// C-h: Back space
			if (!nRepeat)
				nRepeat = 1;
			while (nRepeat--)
				CuKduCd(VK_BACK);
			goto HOOK;

		case 'I':
			// C-i: Tab
			CuKduCd(VK_TAB);
			goto HOOK;

		case 'J':
			// C-x C-j: Kanji
			if (bC_x) {
				ToggleIME();
				goto HOOK;
			} else
				break;

		case 'K':
			// C-k: Shift-End, Shift-Delete, if the cursor is not at EOL (is End Of Line)
			//		Shift-Right, Cut, if the cursor is at EOL
			if (!strnicmp(szApplicationName, "123w.exe", sizeof(szApplicationName))) {
				// C-k: Shift-End, Control-x
				CuSdKduSuCd(VK_END);
				Kdu('W');
				goto HOOK;
			}

			{
				static CString szOriginalClipboardText;
				// Do not try to do these command at once.
				// Clipboard has old data till you go out this function.
				static int nStep = 0;
				static CString szClipboardText;

				switch (nStep) {
				case 0:
					szOriginalClipboardText.Empty();
					if (!GetClipboardText(&szOriginalClipboardText))
						szOriginalClipboardText.Empty();

					if (!CopyNextCharacter())
						goto DO_NOTHING;
					nStep = 1;
					goto RECURSIVE;
				case 1:
					nStep = 0;

					szClipboardText.Empty();
					GetClipboardText(&szClipboardText);

//					{
//						CString sz;
//						sz.Format("%x, %s", szClipboardText.GetAt(0), szClipboardText);
//						AfxMessageBox(sz);
//					}

					if (szClipboardText.IsEmpty()) {	// EOF
						if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
							!strnicmp(szApplicationName, "frontpg.exe", sizeof(szApplicationName)) ||
							!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
							CuKduCd(VK_END);
							CuSdKduSuCd(VK_RIGHT);
							Kdu('W');
							nStep = 2;
							goto RECURSIVE;
						} else if (!strnicmp(szApplicationName, "nlnotes.exe", sizeof(szApplicationName))) {
							CuKduCd(VK_END);
							CuSdKduSuCd(VK_DOWN);
							CuSdKduSuCd(VK_HOME);
							Kdu('W');
							nStep = 2;
							goto RECURSIVE;
						} else {
							// default
							CuKduCd(VK_RIGHT);
							if (!SetClipboardText(&szOriginalClipboardText))
								;//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
							goto HOOK;
						}
					}

					if (szClipboardText.GetAt(0) != VK_RETURN) {
						CuSdK1duK2duSuCd(VK_END, VK_DELETE);

						if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
							!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
							CuKduCd(VK_RETURN);
							CuKduCd(VK_LEFT);
						}

//						CuSdKduSuCd(VK_END);
//						if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
//							!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
//							CuSdKduSuCd(VK_LEFT);
//						}
//						Kdu('W');
					} else {
						CuSdKduSuCd(VK_RIGHT);
						Kdu('W');
					}

					nStep = 2;
					goto RECURSIVE;
				case 2:
					{
						nStep = 0;
						szClipboardText.Empty();
						GetClipboardText(&szClipboardText);

//						CString sz;
//						sz.Format("%x, %x, %x, %x, %x, %x, %s", szClipboardText.GetAt(0), szClipboardText.GetAt(1), szClipboardText.GetAt(2), szClipboardText.GetAt(3), szClipboardText.GetAt(4), szClipboardText.GetAt(5), szClipboardText);
//						AfxMessageBox(sz);

						int nEnter = szClipboardText.Find(VK_RETURN, 1);
						if ( nEnter != -1 ) {
							CuKduCd(VK_RETURN);
							CuKduCd(VK_LEFT);
							szClipboardText = szClipboardText.Left(nEnter);
						}

						nStep = 3;
						goto RECURSIVE;
					}
				case 3:
					nStep = 0;
					if (!szClipboardText.IsEmpty())
						if (!SetClipboardText(&szClipboardText))
							;//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
					goto HOOK;
					break;
				}
			}

		case 'M':
			// C-m: Enter
			if (!nRepeat)
				nRepeat = 1;
			while (nRepeat--)
				CuKduCd(VK_RETURN);
			goto HOOK;

		case 'N':
			// C-n: Down
			if (!nRepeat)
				nRepeat = 1;
			while (nRepeat--)
				CuKduCd(VK_DOWN);
			goto HOOK;

		case 'O':
			// C-o: Kanji
			ToggleIME();
			goto HOOK;

		case 'P':
			// C-p: Up
			if (!nRepeat)
				nRepeat = 1;
			while (nRepeat--)
				CuKduCd(VK_UP);
			goto HOOK;

		case 'S':
			// C-x C-s: Alt-f, Alt-s
			if (bC_x) {
				CuAdKduKduAuCd('F', 'S');
				goto HOOK;
			}

			// C-s: Control-f
			PostMessage(GetFocus(), WM_KEYDOWN, 'F', 0);
			goto HOOK;

		case 'T':
			// C-t: Shift-Left, Shift-Delete, Right Shift-Insert, if the cursor is not at EOL (is End Of Line)
			//		Left, Shift-Right, Shift-Delete, Left, Shift-Insert, Right, if the cursor is at EOL
			{
				static CString szOriginalClipboardText;
				// Do not try to do these command at once.
				// Clipboard has old data till you go out this function.
				static int nTurns = 0;
				switch (nTurns) {
				case 0:
					szOriginalClipboardText.Empty();
					if (!GetClipboardText(&szOriginalClipboardText))
						szOriginalClipboardText.Empty();
//					AfxMessageBox(szOriginalClipboardText);

					// simple version
					if (!strnicmp(szApplicationName, "123w.exe", sizeof(szApplicationName))) {
						// C-t: Left, Shift-Right, Shift-Delete, Left, Shift-Insert, Right
						ReleaseKey(VK_CONTROL);
						Kdu(VK_LEFT);
						DepressKey(VK_SHIFT);
						Kdu(VK_RIGHT);
						Kdu(VK_DELETE);
						ReleaseKey(VK_SHIFT);
						Kdu(VK_LEFT);
						DepressKey(VK_SHIFT);
						Kdu(VK_INSERT);
						ReleaseKey(VK_SHIFT);
						Kdu(VK_RIGHT);
						DepressKey(VK_CONTROL);
						nTurns = 3;
						goto RECURSIVE;
						break;	// needless
					}
				
					if (!CopyBackCharacter())
						goto DO_NOTHING;

					nTurns = 1;
					goto RECURSIVE;
					break;	// needless
				case 1:
					{
						nTurns = 0;
						CString szClipboardText;
						GetClipboardText(&szClipboardText);

//						CString sz;
//						sz.Format("%x, %d, %s", szClipboardText.GetAt(0), szClipboardText.GetLength(), szClipboardText);
//						AfxMessageBox(sz);

						// Top Of File
						if (szClipboardText.IsEmpty() ||		// for normal application
							szClipboardText.GetLength() >= 3) {	// for VC++
							CuKduCd(VK_LEFT);
							nTurns = 3;
							goto RECURSIVE;
						}

						if (!CopyNextCharacter()) {
							nTurns = 3;
							goto RECURSIVE;
						}

						nTurns = 2;
						goto RECURSIVE;
						break;	// needless
					}
				case 2:
					{
						nTurns = 0;
						CString szClipboardText;
						GetClipboardText(&szClipboardText);

//						CString sz;
//						sz.Format("%x, %d, %s", szClipboardText.GetAt(0), szClipboardText.GetLength(), szClipboardText);
//						AfxMessageBox(sz);

						if (!szClipboardText.IsEmpty() &&
							szClipboardText.GetAt(0) != VK_RETURN) {
							ReleaseKey(VK_CONTROL);
							DepressKey(VK_SHIFT);
							Kdu(VK_LEFT);
							Kdu(VK_DELETE);
							ReleaseKey(VK_SHIFT);
							Kdu(VK_RIGHT);
							DepressKey(VK_SHIFT);
							Kdu(VK_INSERT);
							ReleaseKey(VK_SHIFT);
							DepressKey(VK_CONTROL);
						} else {
							if (szClipboardText.GetAt(0) != VK_RETURN)	// EOF
								if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
									!strnicmp(szApplicationName, "frontpg.exe", sizeof(szApplicationName)) ||
									!strnicmp(szApplicationName, "nlnotes.exe", sizeof(szApplicationName)) ||
									!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
									// These applications say "EOL is EOF".
									CuKduCd(VK_END);
								} else {
									// default
									CuKduCd(VK_RIGHT);
								}

							ReleaseKey(VK_CONTROL);
							Kdu(VK_LEFT);
							DepressKey(VK_SHIFT);
							Kdu(VK_RIGHT);
							Kdu(VK_DELETE);
							ReleaseKey(VK_SHIFT);
							Kdu(VK_LEFT);
							DepressKey(VK_SHIFT);
							Kdu(VK_INSERT);
							ReleaseKey(VK_SHIFT);
							Kdu(VK_RIGHT);
							DepressKey(VK_CONTROL);
						}

						nTurns = 3;
						goto RECURSIVE;
						break;	// needless
					}
				case 3:
					nTurns = 0;
					if (!SetClipboardText(&szOriginalClipboardText))
						;//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
					goto HOOK;
					break;	// needless
				}
			}

		case 'V':
			// C-v: Page Down
			if (bOriginalC_v) {
				bOriginalC_v = FALSE;
				goto DO_NOTHING;
			} else {
				if (!nRepeat)
					nRepeat = 1;
				while (nRepeat--)
					CuKduCd(VK_NEXT);
				goto HOOK;
			}

		case 'W':
			// C-x C-w: Alt-f, Alt-a
			if (bC_x) {
				CuAdKduKduAuCd('F', 'A');
				goto HOOK;
			}

			// C-w: Control-x
//			CuSdKduSuCd(VK_DELETE);
			if (IsShiftDown())
				ReleaseKey(VK_SHIFT);
			bOriginalC_x = TRUE;
			Kdu('X');
			goto HOOK;

		case 'X':
			if (bOriginalC_x) {
				bOriginalC_x = FALSE;
				goto DO_NOTHING;
			} else {
				// C-x: only set flag
				bC_x = TRUE;
				goto HOOKX;
			}

		case 'Y':
			// C-y: Control-v
//			CuSdKduSuCd(VK_INSERT);
			bOriginalC_v = TRUE;
			Kdu('V');
			goto HOOK;

		case 'Z':
			if (bOriginalC_z) {
				bOriginalC_z = FALSE;
				goto DO_NOTHING;
			} else {
				// C-z: Alt-Space, n
				CuAdKduKduAuCd(VK_SPACE, 'N');
				goto HOOK;
			}

		case VK_SPACE:
			// C-space: Shift
			if (IsShiftDown())
				ReleaseKey(VK_SHIFT);
			else
				DepressKey(VK_SHIFT);
			goto HOOK;

		case 0xBF:
			// C-/: Control-z
			if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName))) {
				PostMessage(GetFocus(), WM_KEYDOWN, 'Z', 0);
				goto HOOK;
			}
			bOriginalC_z = TRUE;
			Kdu('Z');
			goto HOOK;

		case 0xDC:
			// C-\: Kanji
			ToggleIME();
			goto HOOK;

		case 0xE2:
			// C-BACKSLASH of 106/109 keyboard: Kanji
			ToggleIME();
			goto HOOK;

		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			// C-0...9
			nRepeat = nRepeat * 10 + (wParam - '0');
			goto HOOK0_9;

		default:
			ASSERT(0);
			break;
		}	// switch (wParam)
	}	// if (IsControlDown())

	// M-?
	if (IsAltDown()) {
		switch (wParam) {

		case 'V':
			// M-v: Page Up
			if (!nRepeat)
				nRepeat = 1;
			while (nRepeat--)
				AuKduAd(VK_PRIOR);
			goto HOOK;

		case 'W':
			// M-w: Control-c
			if (IsShiftDown())
				ReleaseKey(VK_SHIFT);
			AuCdKduCuAd('C');
			goto HOOK;

		default:
			ASSERT(0);
			break;
		}	// switch (wParam)
	}	// if (IsAltDown())

	switch (wParam) {
		case 'U':
			// C-x u: Control-z
			if (bC_x) {
				DepressKey(VK_CONTROL);
				PostMessage(GetFocus(), WM_KEYDOWN, 'Z', 0);
				ReleaseKey(VK_CONTROL);
				goto HOOK;
			} else
				break;

		default:
			ASSERT(0);
			break;
	}

DO_NOTHING:
	if (bNumLockChanged)
		ToggleNumLock();
	return ::CallNextHookEx(m_hHook, code, wParam, lParam);

RECURSIVE:
	if (bNumLockChanged)
		ToggleNumLock();
	LRESULT result;
	result = ::CallNextHookEx(m_hHook, code, wParam, lParam);
	ASSERT(0 <= wParam && wParam <= UCHAR_MAX);
	Kdu((BYTE)wParam);
//	return result;
	return TRUE;

HOOK:
	nRepeat	= 0;
HOOK0_9:
	bC_x	= FALSE;
HOOKX:
	if (bNumLockChanged)
		ToggleNumLock();
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// CXkeymacsData Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXkeymacsData::CXkeymacsData()
{
	ClearAll();
}

CXkeymacsData::~CXkeymacsData()
{

}

// set application name
void CXkeymacsData::SetApplicationName(LPCTSTR lpszApplicationName)
{
	m_strApplicationName.Format(lpszApplicationName);
}

// return application name
CString CXkeymacsData::GetApplicationName()
{
	return m_strApplicationName;
}

// set hook or not
void CXkeymacsData::SetEnable(int nCommandType, int nKey, int nEnable)
{
	ASSERT(0 <= nCommandType	|| nCommandType	< MAX_COMMAND_TYPE);
	ASSERT(0 <= nKey			|| nKey			< MAX_KEY);

	m_nEnable[nCommandType][nKey] = nEnable;
}

// return hook or not
int CXkeymacsData::GetEnable(int nCommandType, int nKey)
{
	ASSERT(0 <= nCommandType	|| nCommandType	< MAX_COMMAND_TYPE);
	ASSERT(0 <= nKey			|| nKey			< MAX_KEY);

	return m_nEnable[nCommandType][nKey];
}

// clear all data
void CXkeymacsData::ClearAll()
{
	ZeroMemory(m_nEnable, sizeof(m_nEnable));
	m_strApplicationName.Empty();
}

// set application name
void CXkeymacsDll::SetApplicationName(int nApp, CString szApplicationName)
{
	ZeroMemory(m_szSpecialApp[nApp], sizeof(m_szSpecialApp[nApp]));
	strncpy(m_szSpecialApp[nApp], szApplicationName, sizeof(m_szSpecialApp[nApp]));
}

// return root window of focused window
HWND CXkeymacsDll::GetFocusRoot()
{
	HWND hWnd, hRootWnd;
	for (hRootWnd = hWnd = GetFocus(); hWnd; hWnd = GetParent(hWnd))
		hRootWnd = hWnd;
	return hRootWnd;
}

// set m_nEnable[nApp][nCommandType][nKey] nEnable
void CXkeymacsDll::SetEnable(int nApp, int nCommandType, int nKey, int nEnable)
{
	m_nEnable[nApp][nCommandType][nKey] = nEnable;
}

// Clear data of nApp
void CXkeymacsDll::Clear(int nApp)
{
	if (0 <= nApp && nApp < MAX_APP) {
		ZeroMemory(m_szSpecialApp[nApp], sizeof(m_szSpecialApp[nApp]));
		ZeroMemory(m_nEnable[nApp], sizeof(m_nEnable[nApp]));
	} else
		ASSERT(0);
}

// Set m_hPrevWnd 0 for that KeyboardProc() updates data 
void CXkeymacsDll::UpdateData()
{
	m_hPrevWnd = 0;
}

void CXkeymacsData::SetApplicationTitle(LPCTSTR lpszApplicationTitle)
{
	m_strApplicationTitle.Format(lpszApplicationTitle);
}

CString CXkeymacsData::GetApplicationTitle()
{
	return m_strApplicationTitle;
}

BOOL CXkeymacsDll::GetClipboardText(CString *szClipboardText)
{
	if (!OpenClipboard(NULL)) {
//		AfxMessageBox("Cannot open the Clipboard");
		return FALSE;
	}

	HANDLE hClipboardText;
//	if ((hClipboardText = ::GetClipboardData(CF_TEXT)) == NULL) {
	if ((hClipboardText = ::GetClipboardData(CF_OEMTEXT)) == NULL) {
		DWORD dw = GetLastError();
		CString szMessage;
		szMessage.Format("Unable to get Clipboard data: %d", dw);
//		AfxMessageBox(szMessage);
		CloseClipboard();
		return FALSE;
	}

	szClipboardText->Format("%s", hClipboardText);
	EmptyClipboard();
	CloseClipboard();
	return TRUE;
}

BOOL CXkeymacsDll::SetClipboardText(CString *szClipboardText)
{
	if (!OpenClipboard(NULL)) {
//		AfxMessageBox("Cannot open the Clipboard in SetClipboardText");
		return FALSE;
	}

	int nLength = szClipboardText->GetLength() + 1;
	HGLOBAL hClipboardText = GlobalAlloc(GHND, nLength);
	if (hClipboardText == NULL) {
//		AfxMessageBox("Failed: GlobalAlloc in SetClipboardText");
		return FALSE;
	}

	LPSTR lpStr = (LPSTR)GlobalLock(hClipboardText);
	lstrcpyn(lpStr, *szClipboardText, nLength);
	GlobalUnlock(hClipboardText);
	EmptyClipboard();

	if ((hClipboardText = ::SetClipboardData(CF_OEMTEXT, hClipboardText)) == NULL) {
		DWORD dw = GetLastError();
		CString szMessage;
		szMessage.Format("Unable to set Clipboard data: %d", dw);
//		AfxMessageBox(szMessage);
		CloseClipboard();
		return FALSE;
	}

	CloseClipboard();
	return TRUE;

}
